''***************************************
''*  z8Busdrive v2.2  Objekt CALC       *
''*  Author: Uwe Nickel                 *
''*  Copyright (c) 2011 by UN-Soft      *
''*  See end of file for terms of use.  *
''***************************************

' 
 
CON
 

VAR   
    long  cog
    

PUB start (bws_adr,bws_len,bmp_adr,bmp_len,col_adr,col_len,vgamod_adr,calccmd_adr,xyzdata_adr)
     scr_buff    := bws_adr
     len         := bws_len   
     bmp_buff    := bmp_adr
     len_bmp     := bmp_len
     col_buff    := col_adr
     len_col     := col_len
     vgamode_adr := vgamod_adr
     calc_cmd    := calccmd_adr
     calc_adr    := xyzdata_adr
     

      
     '' Stop driver - frees a cog
     if cog
       cogstop(cog~ -  1)
     
   
     cog := cognew(@CALC,0) + 1                                       'Berechnung-Cog starten
               

DAT 'Berechnung- Cog
org 0
'******************************************************************************************************
'---- Mainloop ----------------------------------------------------------------------------------------
'******************************************************************************************************                  
CALC              mov Mem, par
                  rdlong vgamode, vgamode_adr      'VGA-Start-Mode holen
                  rdlong temp2, calc_adr           'Standardfarben holen
                  call #col_set                    'und setzen
        
Cmd_start         rdbyte temp2, calc_cmd           'einlesen Kommando aus bergabezelle nach Variable
                  cmp temp2, #$00          wz
         if_z     jmp #bws    
  
                  cmp temp2, #$21          wz
         if_z     jmp #set_col         
                  cmp temp2, #$22          wz
         if_z     jmp #set_moni
                  cmp temp2, #$24          wz
         if_z     jmp #clear_bmp
                  cmp temp2, #$25          wz
         if_z     jmp #set_bmp

                  jmp #Cmd_start


              
'********************************************************************************************************
'---- Common Parts Mainloop -----------------------------------------------------------------------------
'********************************************************************************************************
bws               call #bws2bmp
                  jmp #Cmd_start 

Cmdx              mov temp2, #$FF                   'Cmd mit FF beschreiben -> ready
                  wrbyte temp2, calc_cmd                             
                  jmp #Cmd_start

'********************************************************************************************************  
'---- Subroutinen Monitor -------------------------------------------------------------------------------
'********************************************************************************************************
clear_bmp         mov temp2, #0     
                  call #bmp_set
                  jmp #Cmdx                         'und zurck
                  
'------------------------------------------------------------------------------------------------------ 
set_moni          rdlong vgamode, vgamode_adr       'Ausgabemodus einlesen (4 Bytes)
                  test vgamode, #$08       wz       'Bit 3 testen, ob Cls
         if_nz    jmp #clear_bmp                    'sonst Bitmappuffer lschen
                  jmp #Cmdx                         'und zurck
                  
'------------------------------------------------------------------------------------------------------ 
set_bmp           rdlong temp2, calc_adr            'auszugebenden Wert einlesen
                  call #bmp_set                     'und nach Bitmappuffer schreiben
                  jmp #Cmdx                         'und zurck
                  
'------------------------------------------------------------------------------------------------------ 
set_col           rdlong temp2, calc_adr
                  call #col_set
                  jmp #Cmdx

'------------------------------------------------------------------------------------------------------
'-------- Berechnung fr 160 x 240 Pixel --------------------------------------------------------------
'------------------------------------------------------------------------------------------------------
bws2bmp           mov xorx, #$00
                  mov bmp_ptr, bmp_buff             'Adresse Bitmapspeichr nach Pointer  
                  mov scr_ptr, scr_buff             'Adresse TINY -BWS nach Pointer
               
                  test vgamode, #1         wz       'Zeile 0 anzeigen?
   if_z           add scr_ptr, #$20                 'Ja, dann Bilschirmpointer neu berechnen
                  test vgamode, #$4         wz      'Test vgamode auf invertieren
   if_z           mov xorx, xorx_mask
    
                  mov x4, #60                       'Zeilenzahl Grafikspeicher TINY
                  
Zeile_rd          mov bmp_ptrtemp, bmp_ptr      
                  mov scr_ptrtemp, scr_ptr

                  add bmp_ptrtemp,#3                'links 3 Bytes - linker Rand    
                  mov x1, #8                        'Bytezahl graf. BWS TINY pro Zeile = 8 Bytes
                  
:mx               rdbyte temp2, scr_ptrtemp         'read BWS -> temp2
                  shl temp2, #24
                  mov temp3, #8                     'Reihenfolge Bits vertauschen
:xx               shl temp2, #1    wc
                  rcr temp , #1
                  rcr temp , #1        
                  djnz temp3, #:xx
                  shr temp, #16
                  xor temp, xorx
         
:zy               wrword temp, bmp_ptrtemp         'Byte nach Bitmappuffer schreiben  
      
                  add bmp_ptrtemp, #2              'Bitmappointer auf nchstes Word    
                  add scr_ptrtemp, #1              'BWS-Pointer auf nchstes Byte 
                  djnz x1, #:mx                    'zurck bis Zeilenende
              
                  add bmp_ptr, #20                 'nchster Zeilenanfang im Bitmappuffer (160 Pixel=20x8 bit)
                  add scr_ptr, #8 
                  djnz x4, #Zeile_rd               'nchste Zeile im Grafikspeicher TINY, 
 
 
bws2bmp_ret       ret         
                  
'-------------------------------------------------------------------------------------------------------
'---- Common -Parts  -----------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------------------------
col_set           mov temp3, temp2                 'Verdopplung word --> long
                  shl temp3, #16
                  or  temp2, temp3 
                  mov len_ptr, len_col             'Lnge Farbspeicher
                  shr len_ptr, #1                  'Umrechnen auf Long
                  mov scr_ptr, col_buff            'Adresse Farbspeicher
                  jmp #fill_block
bmp_set           mov len_ptr, len_bmp              'Lnge Bitmap-Puffer nach Pointer
                  mov scr_ptr, bmp_buff             'Adresse Bitmap-Puffer nach Pointer

fill_block        wrlong temp2, scr_ptr             'Bitmappufferadresse bescheiben 
                  add scr_ptr, #4                   'nchste Long-Adresse
                  djnz len_ptr, #fill_block         'zurck, wenn Lnge grer 0
fill_block_ret
bmp_set_ret
col_set_ret       ret                               'und zurck
                   
'------------------------------------------------------------------------------------------------------                                       
 
'---------------------------------------------------------------------------------------------------------

'*********************************************************************************************************
'---- Data & Variable ------------------------------------------------------------------------------------
'*********************************************************************************************************                    
    
 scr_buff      long  0      
 bmp_buff      long  0
 col_buff      long  0 
 len           long  0 
 len_bmp       long  0
 len_col       long  0   
 vgamode_adr   long  0
                                  
 calc_cmd      long  0           
 calc_adr      long  0
 xorx_mask     long  $FFFF


Mem            res   1
vgamode        res   1
temp           res   1
temp2          res   1
temp3          res   1
ptr            res   1
x1             res   1
x2             res   1   
x3             res   1
x4             res   1 
scr_ptr        res   1
scr_end        res   1 
bmp_ptr        res   1
len_ptr        res   1
bmp_ptrtemp    res   1
scr_ptrtemp    res   1
xorx           res   1