''***************************************
''*  z8-Emulator  Objekt I/O & Interrupt*
''*  Author: Uwe Nickel                 *
''*  Copyright (c) 2012 by UN-Soft      *
''*  See end of file for terms of use.  *
''***************************************

' 
 
CON
 

VAR   
    long  cog
    

PUB start (z8reg, P2port,X0,X1,X2,X3,X4,X5,X6,X7)

 z8reg_adr := z8reg    'Basis-Adresse Register im HUB-Ram
 P2_mask   := P2port
 P30_mask  := X0
 P31_mask  := X1 
 P32_mask  := X2 
 P33_mask  := X3 
 P34_mask  := X4 
 P35_mask  := X5 
 P36_mask  := X6
 P37_mask  := X7

      
     '' Stop driver - frees a cog
     if cog
       cogstop(cog~ -  1)
     
   
     cog := cognew(@main,0) + 1                                       'Berechnung-Cog starten
               

DAT 'Berechnung- Cog
org 0
'******************************************************************************************************
'---- Mainloop ----------------------------------------------------------------------------------------
'******************************************************************************************************                  
main              mov Mem, par

'......Portregister 00-03...............................
                  mov z8reg_ptr, z8reg_adr
                  mov R0_adr, z8reg_ptr
                  add z8reg_ptr, #1
                  mov R1_adr, z8reg_ptr
                  add z8reg_ptr, #1
                  mov R2_adr, z8reg_ptr
                  add z8reg_ptr, #1
                  mov R3_adr, z8reg_ptr
'......Systemregister F0 - FB...........................   
                  add z8reg_ptr,#$ED          
                  mov SIO_adr, z8reg_ptr           'F0
                  add z8reg_ptr, #1
                  mov TMR_adr, z8reg_ptr           'F1
                  add z8reg_ptr, #1
                  mov T1_adr, z8reg_ptr            'F2
                  add z8reg_ptr, #1
                  mov PRE1_adr, z8reg_ptr          'F3
                  add z8reg_ptr, #1
                  mov T0_adr, z8reg_ptr            'F4
                  add z8reg_ptr, #1
                  mov PRE0_adr, z8reg_ptr          'F5
                  add z8reg_ptr, #1
                  mov P2M_adr, z8reg_ptr           'F6
                  add z8reg_ptr, #1
                  mov P3M_adr, z8reg_ptr           'F7
                  add z8reg_ptr, #1
                  mov P01M_adr, z8reg_ptr          'F8
                  add z8reg_ptr, #1
                  mov IPR_adr, z8reg_ptr           'F9
                  add z8reg_ptr, #1
                  mov IRQ_adr, z8reg_ptr           'FA
                  add z8reg_ptr, #1
                  mov IMR_adr, z8reg_ptr           'FB
                  
'......I/O-Pinstatus Port 3 ermitteln und ausgeben an Propeller-Pins......................
                  mov io_mask, #$00          wz       'Z-Flag setzen fr mux
                  muxz io_mask, P30_mask
                  muxnz io_mask, P37_mask
                  muxz io_mask, P31_mask
                  muxnz io_mask, P36_mask
                  muxz io_mask, P33_mask
                  muxnz io_mask, P34_mask
                  muxz io_mask, P32_mask
                  muxnz io_mask, P35_mask
                  mov dira, io_mask                'I/O-Richtung festlegen

'......Timer fr Emulation vorbereiten....................................................                  
                  mov ctra, ctra_val               'Timer im Cog
                  mov frqa, frqa_val               'fr Emulation T1
                  mov phsa, #0                     'vorbereiten
                                  
'-------------------------------------------------------------------------------------------                  
go                mov P2M, #0                wz
                  rdbyte P2M, P2M_adr              'Port2 I/O-Richtungsregister lesen  (Bit=1 -> Input)
                  shl P2M, P2_mask                 'verschieben um Portpinnummer     
                  muxz dira, P2M                   'I/O-Richtung festlegen
                  
 '.....P2 - Emulation.....................................................................
                  rdbyte temp, R2_adr              'R02 einlesen 
                  shl temp, P2_mask                'verschieben um Portpinnummer
                  muxz outa, temp                  'und ausgeben auf Propeller-Pins
                  mov temp, ina                    'Inputs einlesen
                  shr temp, P2_mask                'verschieben um Portpinnummer 
                  wrbyte temp, R2_adr              'nach R02 schreiben

'......T1 - Emulation....................................................................
'
'......mit Zhlvariable..................................................................            
                  sub t1_val, t1_const       wc    'Zhler erniedrigen
                  mov temp, t1_val                 'Wert umformen
                  shr temp, #24 
                  wrbyte temp, T0_adr              'schreiben

'......mit Zhler des Cog ..............................................................                  
{                rdbyte temp2, T0_adr             'letzten Wert T0 holen
                  mov temp, phsa                   'aktuellen Wert Cog-Timer holen
                  shr temp, #24
                  xor temp, #$FF                   'invertieren, wegen Abwrtszhler
                  wrbyte temp, T0_adr              'und schreiben
                  cmp temp2, temp            wc    'alt < aktuell -> Nulldurchgang 
}
'......per IRQ..................................................................................
'                  rdbyte temp, IMR_adr             'IMR-Register einlesen
'                  test temp, #%1000_0000     wz    'Globale Int-Sperre?
'        if_nz     jmp #Timer_end

'                  mov z8reg_ptr, z8reg_adr
'                  add z8reg_ptr, #$FA
'                  mov IRQ_adr, z8reg_ptr
'                  rdbyte temp, IRQ_adr             'IRQ-Register einlesen
'                  test temp, #%00010000      wz    'letzte Anforderung verarbeitet?
'        if_nz     jmp #Timer_end                   'wenn nein Sprung, sonst
'        if_c      or temp, #%00010000              'wenn Interruptereignis vorhanden (C=1), 
'        if_c      wrbyte temp, IRQ_adr             'dann setzen und schreiben
Timer_end

'......per direktem Beschreiben R54 fr TINY....................................................
                  mov z8reg_ptr, z8reg_adr         'Register 54 
                  add z8reg_ptr, #$54
                  wrbyte temp, z8reg_ptr           'schreiben
                  

'------------------------------------------------------------------------------------------------------                                       
                  jmp #go
'---------------------------------------------------------------------------------------------------------

'*********************************************************************************************************
'---- Data & Variable ------------------------------------------------------------------------------------
'*********************************************************************************************************                    
    
z8reg_adr     long   0
P2_mask       long   0
P30_mask      long   0
P31_mask      long   0
P32_mask      long   0
P33_mask      long   0
P34_mask      long   0
P35_mask      long   0
P36_mask      long   0
P37_mask      long   0 
ctra_val      long   %0_00001_010_00000000_000000_000_000000
frqa_val      long   $008f_0100
t1_val        long   $ff00_0000
t1_const      long   $001f_ffff 


Mem            res   1
io_mask        res   1
temp           res   1
temp2          res   1
z8reg_ptr      res   1

R0_adr         res   1
R1_adr         res   1
R2_adr         res   1
R3_adr         res   1

P01M_adr       res   1            'F8
P2M_adr        res   1            'F6
P3M_adr        res   1            'F7
TMR_adr        res   1            'F1
PRE0_adr       res   1            'F5
T0_adr         res   1            'F4
PRE1_adr       res   1            'F3
T1_adr         res   1            'F2
IRQ_adr        res   1            'FA
SIO_adr        res   1            'F0                
IPR_adr        res   1            'F9
IMR_adr        res   1            'FB

P2M            res   1
IRQ            res   1
 